RSAKeyPairRawCodec (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.key.rsa.RSAKeyPairRawCodec,RSAKeyPairRawCodec class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.key.rsa
Class RSAKeyPairRawCodec

    java.lang.Object
      |
      +--gnu.crypto.key.rsa.RSAKeyPairRawCodec

All Implemented Interfaces:
  IKeyPairCodec

public class RSAKeyPairRawCodec
extends java.lang.Object
implements IKeyPairCodec

An object that implements the `IKeyPairCodec` interface for the Raw format to use with RSA keypairs.

Field Summary

Fields inherited from interface gnu.crypto.key.IKeyPairCodec
`RAW_FORMAT`

Constructor Summary
`RSAKeyPairRawCodec()`

Method Summary
`java.security.PrivateKey` | `decodePrivateKey(byte[] k)` Decodes an instance of an external private key into its native Java representation.
`java.security.PublicKey` | `decodePublicKey(byte[] k)` Decodes an instance of an external public key into its native Java representation.
`byte[]` | `encodePrivateKey(java.security.PrivateKey key)` Returns the encoded form of the designated RSA private key according to the Raw format supported by this library.
`byte[]` | `encodePublicKey(java.security.PublicKey key)` Returns the encoded form of the designated RSA public key according to the Raw format supported by this library.
`int` | `getFormatID()` Returns the unique identifier (within this library) of the format used to externalise public and private keys.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RSAKeyPairRawCodec

    public RSAKeyPairRawCodec()

Method Detail

### getFormatID

    public int getFormatID()

  Description copied from interface: `IKeyPairCodec`

  Returns the unique identifier (within this library) of the format used to externalise public and private keys.

  Specified by:
    `getFormatID` in interface `IKeyPairCodec`
  Returns:
    the identifier of the format, the object supports.

### encodePublicKey

    public byte[] encodePublicKey(java.security.PublicKey key)

  Returns the encoded form of the designated RSA public key according to the Raw format supported by this library.

  The Raw format for an RSA public key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the value of the literal `Registry.MAGIC_RAW_RSA_PUBLIC_KEY`,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the RSA parameter `n` (the modulus) in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `n`,
  6. 4-byte count of following bytes representing the RSA parameter `e` (the public exponent) in internet order,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `e`.

  Specified by:
    `encodePublicKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.
  Throws:
    `java.lang.IllegalArgumentException` - if the designated key is not an RSA one.

### decodePublicKey

    public java.security.PublicKey decodePublicKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`

  Decodes an instance of an external public key into its native Java representation.

  Specified by:
    `decodePublicKey` in interface `IKeyPairCodec`
  Parameters:
    `k` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a public key, reconstructed from the designated input.

### encodePrivateKey

    public byte[] encodePrivateKey(java.security.PrivateKey key)

  Returns the encoded form of the designated RSA private key according to the Raw format supported by this library.

  The Raw format for an RSA private key, in this implementation, is a byte sequence consisting of the following:

  1. 4-byte magic consisting of the value of the literal `Registry.MAGIC_RAW_RSA_PRIVATE_KEY`,
  3. 1-byte version consisting of the constant: 0x01,
  4. 4-byte count of following bytes representing the RSA parameter `p` (the first prime factor of the modulus) in internet order,
  5. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `p`,
  6. 4-byte count of following bytes representing the RSA parameter `q` (the second prime factor of the modulus) in internet order,
  7. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `q`,
  8. 4-byte count of following bytes representing the RSA parameter `e` (the public exponent) in internet order,
  9. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `e`,
  10. 4-byte count of following bytes representing the RSA parameter `d` (the private exponent) in internet order,
  11. n-bytes representation of a `BigInteger` obtained by invoking the `toByteArray()` method on the RSA parameter `d`,

  Specified by:
    `encodePrivateKey` in interface `IKeyPairCodec`
  Parameters:
    `key` - the key to encode.
  Returns:
    the Raw format encoding of the designated key.

### decodePrivateKey

    public java.security.PrivateKey decodePrivateKey(byte[] k)

  Description copied from interface: `IKeyPairCodec`

  Decodes an instance of an external private key into its native Java representation.

  Specified by:
    `decodePrivateKey` in interface `IKeyPairCodec`
  Parameters:
    `k` - the source of the externalised key to decode.
  Returns:
    a concrete instance of a private key, reconstructed from the designated input.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.